////////////////////////////////////		
//MADE BY A SIMPLE VIRTUAL SAILOR //
////////////////////////////////////

#define MAX_OFFICER_TYPES 7	//number of different officers we should have now, to be changed soon!

#define OFFIC_TYPECLASS_FIRSTMATE 0
#define OFFIC_TYPECLASS_BOATSWAIN 1
#define OFFIC_TYPECLASS_QMASTER 2
#define OFFIC_TYPECLASS_GUNNER 3
#define OFFIC_TYPECLASS_NAVIGATOR 4
#define OFFIC_TYPECLASS_CARPENTER 5
#define OFFIC_TYPECLASS_DOCTOR 6

/*
// designed for the junior roles
// not yet available
#define OFFIC_TYPECLASS_SECONDMATE = 7;
#define OFFIC_TYPECLASS_BOATSWAIN_JR = 8;
#define OFFIC_TYPECLASS_QMASTER_JR = 9;
#define OFFIC_TYPECLASS_GUNNER_JR = 10;
#define OFFIC_TYPECLASS_NAVIGATOR_JR = 11;
#define OFFIC_TYPECLASS_CARPENTER_JR = 12;
#define OFFIC_TYPECLASS_DOCTOR_JR = 13;
*/

object Officer_type[MAX_OFFICER_TYPES];

void InitOfficerTypes()
{
	ref officer;
	for (int n = 0; n < MAX_OFFICER_TYPES; n++)
	{
		makeref(officer, Officer_type[n]);
		officer.id = "officer_type_" + n;
	}


	/* check for being companion / main character instead
	//Captain - all skill, all perks, for the moment.
	makeref(officer, Officer_type[OFFIC_TYPECLASS_CAPTAIN]);
	officer.name = "Captain";
	officer.skill.Leadership = 2;
	officer.skill.Fencing = 2;
	officer.skill.Sailing = 2;
	officer.skill.Accuracy = 2;
	officer.skill.Cannons = 2;
	officer.skill.Grappling = 2;
	officer.skill.Repair = 2;
	officer.skill.Defence = 2;
	officer.skill.Commerce = 2;
	officer.skill.Sneak = 2;

	officer.perk.BasicDefense = 1;
	officer.perk.AdvancedDefense = 1;
	officer.perk.Toughness = 1;
	officer.perk.CriticalHit = 1;
	officer.perk.SwordplayProfessional = 1;
	officer.perk.Rush = 1;
	officer.perk.Gunman = 1;
	officer.perk.GunProfessional = 1;
	officer.perk.IronWill = 1;
	officer.perk.SharedExperience = 1;
	officer.perk.BasicLandOwner = 1;
	officer.perk.FastReload = 1;
	officer.perk.ImmediateReload = 1;
	officer.perk.HullDamageUp = 1;
	officer.perk.SailsDamageUp = 1;
	officer.perk.CrewDamageUp = 1;
	officer.perk.CriticalShoot = 1;
	officer.perk.LongRangeShoot = 1;
	officer.perk.CannonProfessional = 1;
	officer.perk.LongRangeGrappling = 1;
	officer.perk.GrapplingProfessional = 1;
	officer.perk.InstantBoarding = 1;
	officer.perk.MusketsShoot = 1;
	officer.perk.BasicBattleState = 1;
	officer.perk.AdvancedBattleState = 1;
	officer.perk.ShipDefenseProfessional = 1;
	officer.perk.LightRepair = 1;
	officer.perk.InstantRepair = 1;
	officer.perk.ShipSpeedUp = 1;
	officer.perk.ShipTurnRateUp = 1;
	officer.perk.StormProfessional = 1;
	officer.perk.Turn180 = 1;
	officer.perk.SandbankManeuver = 1;
	officer.perk.SailingProfessional = 1;
	officer.perk.BasicCommerce = 1;
	officer.perk.AdvancedCommerce = 1;
	officer.perk.Trustworthy = 1;
	officer.perk.Brander = 1;
	officer.perk.Troopers = 1;
	*/

	//First Mate
	makeref(officer, Officer_type[OFFIC_TYPECLASS_FIRSTMATE]);
	officer.name = "First_Mate";
	officer.skill.Leadership = 2;
	officer.skill.Fencing = 0;
	officer.skill.Sailing = 1;
	officer.skill.Accuracy = 0;
	officer.skill.Cannons = 0;
	officer.skill.Grappling = 0;
	officer.skill.Repair = 0;
	officer.skill.Defence = 0;
	officer.skill.Commerce = 0;
	officer.skill.Sneak = 0;

	// seems to be personall skill...
	//officer.perk.IronWill  = 1;
	officer.perk.Brander = 1;
	officer.perk.Troopers = 1;

	//Quarter Master - Master Purser in fact.
	makeref(officer, Officer_type[OFFIC_TYPECLASS_QMASTER]);
	officer.name = "QMaster";
	officer.skill.Leadership = 0;
	officer.skill.Fencing = 0;
	officer.skill.Sailing = 0;
	officer.skill.Accuracy = 0;
	officer.skill.Cannons = 0;
	officer.skill.Grappling = 0;
	officer.skill.Repair = 1;
	officer.skill.Defence = 0;
	officer.skill.Commerce = 2;
	officer.skill.Sneak = 0;

	officer.perk.BasicCommerce = 1;
	officer.perk.AdvancedCommerce = 1;
	officer.perk.Trustworthy = 1;
	officer.perk.BasicLandOwner = 1;

	//Doctor
	makeref(officer, Officer_type[OFFIC_TYPECLASS_DOCTOR]);
	officer.name = "Doc";
	officer.skill.Leadership = 0;
	officer.skill.Fencing = 0;
	officer.skill.Sailing = 0;
	officer.skill.Accuracy = 0;
	officer.skill.Cannons = 0;
	officer.skill.Grappling = 0;
	officer.skill.Repair = 0;
	officer.skill.Defence = 2;
	officer.skill.Commerce = 1;
	officer.skill.Sneak = 0;

	officer.perk.BasicBattleState = 1;
	officer.perk.AdvancedBattleState = 1;
	officer.perk.ShipDefenseProfessional = 1;
	
	//Cannoneer
	makeref(officer, Officer_type[OFFIC_TYPECLASS_GUNNER]);
	officer.name = "MGunner";
	officer.skill.Leadership = 0;
	officer.skill.Fencing = 0;
	officer.skill.Sailing = 0;
	officer.skill.Accuracy = 2;
	officer.skill.Cannons = 2;
	officer.skill.Grappling = 0;	
	officer.skill.Repair = 0;
	officer.skill.Defence = 0;
	officer.skill.Commerce = 0;
	officer.skill.Sneak = 0;

	officer.perk.FastReload = 1;
	officer.perk.ImmediateReload = 1;
	officer.perk.HullDamageUp = 1;
	officer.perk.SailsDamageUp = 1;
	officer.perk.CrewDamageUp = 1;
	officer.perk.CriticalShoot = 1;
	officer.perk.LongRangeShoot = 1;
	officer.perk.CannonProfessional = 1;

	//Navigator - what is he supposed to do, exactly?...
	makeref(officer, Officer_type[OFFIC_TYPECLASS_NAVIGATOR]);
	officer.name = "Navigator";
	officer.skill.Leadership = 1;
	officer.skill.Fencing = 0;
	officer.skill.Sailing = 2;
	officer.skill.Accuracy = 0;
	officer.skill.Cannons = 0;
	officer.skill.Grappling = 0;	
	officer.skill.Repair = 0;
	officer.skill.Defence = 0;
	officer.skill.Commerce = 0;
	officer.skill.Sneak = 0;

	officer.perk.ShipSpeedUp = 1;
	officer.perk.ShipTurnRateUp = 1;
	officer.perk.StormProfessional = 1;
	officer.perk.Turn180 = 1;
	officer.perk.SandbankManeuver = 1;
	officer.perk.SailingProfessional = 1;

	//Carpenter
	makeref(officer, Officer_type[OFFIC_TYPECLASS_CARPENTER]);
	officer.name = "Carpenter";
	officer.skill.Leadership = 0;
	officer.skill.Fencing = 0;
	officer.skill.Sailing = 0;
	officer.skill.Accuracy = 0;
	officer.skill.Cannons = 0;
	officer.skill.Grappling = 0;	
	officer.skill.Repair = 2;
	officer.skill.Defence = 1;
	officer.skill.Commerce = 0;
	officer.skill.Sneak = 0;

	officer.perk.LightRepair = 1;
	officer.perk.InstantRepair = 1;

	//Boatswain
	makeref(officer, Officer_type[OFFIC_TYPECLASS_BOATSWAIN]);
	officer.name = "Boatswain";
	officer.skill.Leadership = 1;
	officer.skill.Fencing = 0;
	officer.skill.Sailing = 0;
	officer.skill.Accuracy = 0;
	officer.skill.Cannons = 0;
	officer.skill.Grappling = 2;
	officer.skill.Repair = 0;
	officer.skill.Defence = 0;
	officer.skill.Commerce = 0;
	officer.skill.Sneak = 0;

	officer.perk.LongRangeGrappling = 1;
	officer.perk.GrapplingProfessional = 1;
	officer.perk.InstantBoarding = 1;
	officer.perk.MusketsShoot = 1;

	/*
	// does not contribute anything - so no need to keep it as special role
	//Master at arms/abordage: this one is a little tricky as well...
	makeref(officer, Officer_type[OFFIC_TYPECLASS_FIGHTER]);
	officer.name = "Deck_Fighter";
	officer.skill.Leadership = 0;
	officer.skill.Fencing = 0;
	officer.skill.Sailing = 0;
	officer.skill.Accuracy = 0;
	officer.skill.Cannons = 0;
	officer.skill.Grappling = 0;
	officer.skill.Repair = 0;
	officer.skill.Defence = 0;
	officer.skill.Commerce = 0;
	officer.skill.Sneak = 0;
	*/
}

int GetEffectiveSkill(ref character, string skillName)
{
	int skillPoints = GetCharacterSkill(character, skillName);
	return GetEffectiveSkillByValue(character, skillName, skillPoints);
}

int CalcEffectiveSkill(ref Character, string skillName)
{
	int skillPoints = CalcCharacterSkill(character, skillName);
	return GetEffectiveSkillByValue(character, skillName, skillPoints);
}

int GetEffectiveSkillByValue(ref character, string skillName, int skillPoints)
{
	// TODO: do we need to check main char or is it included in companions?
	// seems as if main char is companion 0...
	if(IsCompanion(character) || skillName == SKILL_FENCING)
	{
		return skillPoints;
	}

	if(CheckAttribute(character, "quest.officerTypeClass"))
	{
		int skillFactor = sti(Officer_type[sti(character.quest.officerTypeClass)].skill.(skillName)); // KK
		// factor: can be 0, 1, 2:
		// 1: half contribution
		// 2: full contribution
		
		// calculate result = points * factor / 2
		// two variants: floor(result) or ceil(result)
		
		// this one corresponds to floor(result)
		// return skillPoints * skillFactor / 2;
		
		// this one corresponds to ceil(result)

		return (skillPoints * skillFactor + 1) / 2;
	}
	
	return 0;
}

void ApplyOfficerTypeClass(ref character)
{
	switch (character.quest.officertype)
	{
		case OFFIC_TYPE_BOATSWAIN:
			character.quest.officerTypeClass = OFFIC_TYPECLASS_BOATSWAIN;
		break;
		case OFFIC_TYPE_CANNONEER:
			character.quest.officerTypeClass = OFFIC_TYPECLASS_GUNNER;
		break;
		case OFFIC_TYPE_QMASTER:
			character.quest.officerTypeClass = OFFIC_TYPECLASS_QMASTER;
		break;
		case OFFIC_TYPE_NAVIGATOR:
			character.quest.officerTypeClass = OFFIC_TYPECLASS_NAVIGATOR;
		break;
		case OFFIC_TYPE_FIRSTMATE:
			character.quest.officerTypeClass = OFFIC_TYPECLASS_FIRSTMATE;
		break;
		case OFFIC_TYPE_CARPENTER:
			character.quest.officerTypeClass = OFFIC_TYPECLASS_CARPENTER;
		break;
		case OFFIC_TYPE_DOCTOR:
			character.quest.officerTypeClass = OFFIC_TYPECLASS_DOCTOR;
		break;
	}
}

void SetModifyValuesForRole(ref character, int primaryModify, int secondaryModify, int skillVariation, int fencing, int sneak)
{
	if(!CheckAttribute(character, "quest.officerTypeClass"))
	{
		ApplyOfficerTypeClass(character);
	}
	ref officer;
        makeref(officer, Officer_type[sti(character.quest.officerTypeClass)]);

	int skillFactor = sti(officer.skill.Leadership);
	int modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.LeadershipModify = modify;

	character.quest.FencingModify = fencing;

	skillFactor = sti(officer.skill.Sailing);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.SailingModify = modify;

	skillFactor = sti(officer.skill.Accuracy);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.AccuracyModify = modify;

	skillFactor = sti(officer.skill.Cannons);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.CannonsModify = modify;

	skillFactor = sti(officer.skill.Grappling);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.GrapplingModify = modify;

	skillFactor = sti(officer.skill.Repair);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.RepairModify = modify;

	skillFactor = sti(officer.skill.Defence);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.DefenseModify = modify;

	skillFactor = sti(officer.skill.Commerce);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.CommerceModify = modify;

	character.quest.SneakModify = sneak;
}
